----------------------------------------------------------------------------------
-- ECE 3401 Spring 2024: Programming Assignment 1
-- University of Connecticut
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity pa1 is
   port(clk, reset : in std_logic; -- Clock and Reset input signals
        A, B, C, D : in unsigned(15 downto 0); -- A, B, C, and D are 16 bit input signals to ALU 		               
        m1_sel, m2_sel : in unsigned(1 downto 0); -- MUX control input signals
        r1_en, r2_en : in std_logic; -- Register enable input signals
        alu1_sel, alu2_sel : in unsigned(1 downto 0); -- ALU selection input signals
        Z1, Z2 : out unsigned(31 downto 0)); -- Output signals
end pa1;

architecture Behavioral of pa1 is 

	signal alu1_in_X, alu1_in_Y : unsigned(15 downto 0) := (others => '0'); -- ALU1 input signals
	signal alu1_out : unsigned(31 downto 0) := (others => '0'); -- ALU1 output signal
	
	signal alu2_in_X, alu2_in_Y : unsigned(15 downto 0) := (others => '0'); -- ALU2 input signals
	signal alu2_out : unsigned (31 downto 0) := (others => '0'); -- ALU2 output signal
	
	signal r1_in, r2_in: unsigned(31 downto 0) := (others => '0'); -- 32-bit r1 and r2 input signals
	signal r1_out, r2_out: unsigned(31 downto 0) := (others => '0'); -- 32-bit r1 and r2 output signals
	
begin

	-- Entity instantiations
	-- Note, entity instantiations are one way to instantiate a module (the other being component instantiations)
	ALU1 : entity work.alu
	   port map (TODO: Complete port map for ALU1 here);
	
	ALU2: entity work.alu
	   port map (TODO: Complete port map for ALU2 here);

	R1 : entity work.dff
	   port map (TODO: Complete port map for R1 here);
		
	R2 : entity work.dff
	   port map (TODO: Complete port map for R2 here);

	--TODO: Your logic for the overall PA1 module here

end Behavioral;
