----------------------------------------------------------------------------------
-- ECE 3401 Spring 2024: Programming Assignment 1's Second Test Bench
-- University of Connecticut
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
 
entity testbench2 is
end testbench2;
 
architecture Behavior OF testbench2 IS 
 
    component pa1
    port(clk, reset : in  std_logic;
         m1_sel, m2_sel : in  unsigned(1 downto 0);
         r1_en, r2_en : in std_logic;
         alu1_sel, alu2_sel : in  unsigned(1 downto 0);
         A, B, C, D : in  unsigned(15 downto 0);
         Z1, Z2 : out  unsigned(31 downto 0));
    end component;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
   
   -- numerical input values (you may temporarily change these for testing / debugging)
   constant a_int : integer := 5;
   constant b_int : integer := 6;
   constant c_int : integer := 7;
   constant d_int : integer := 8;
   
   --Since we are working in the unsigned bit vector domain, we convert a, b, c, and d
   --using the to_unsigned(x, len) function, where x is integer to convert, and len 
   --is the width of the bit-vector we are creating. ALU inputs are 32 bits.
   signal a : unsigned(15 downto 0) := to_unsigned(a_int, 16);
   signal b : unsigned(15 downto 0) := to_unsigned(b_int, 16);
   signal c : unsigned(15 downto 0) := to_unsigned(c_int, 16);
   signal d : unsigned(15 downto 0) := to_unsigned(d_int, 16);
   
   -- Inputs 
   signal clk, reset, r1_en, r2_en : std_logic := '0';
   signal alu1_sel, alu2_sel : unsigned(1 downto 0) := (others => '0');
   signal m1_sel, m2_sel : unsigned(1 downto 0) := (others => '0');

   -- Outputs
   signal Z1, Z2 : unsigned(31 downto 0);
 
begin
   
   -- Instantiate the Unit Under Test (UUT)
   uut: pa1 port map (
          clk => clk,
          reset => reset,
          m1_sel => m1_sel,
          m2_sel => m2_sel,
          r1_en => r1_en,
          r2_en => r2_en,
          alu1_sel => alu1_sel,
          alu2_sel => alu2_sel,
          A => a,
          B => b,
          C => c,
          D => d,
          Z1 => Z1,
          Z2 => Z2);

   -- Clock process definitions
   clk_process: process
   begin
	clk <= '0';
	wait for clk_period/2;
	clk <= '1';
	wait for clk_period/2;
   end process;

     -- Stimulus process
   stim_proc: process
   begin	
        
        --DO NOT CHANGE 
        -------------------
        A <= a;          --
        B <= b;          --
        C <= c;          --
        D <= d;          --
        -------------------
		
        --TODO: Your testbench simulatuon code here to calculate 
        --g(a, b, c) and g(c, d, a) as described in PA1 doc section 3.2

        wait for 5*clk_period; 
        
    end process;

end Behavior;
